\ Open Firmware startup script

\ The disk-loaded version of Open Firmware loads this file
\ as the final step prior to auto-booting.  You can put
\ patches or customization herein.

\ Enable the PS/2 interrupts from the EC chip
: fix-interrupt-routing  ( -- )
   \ (5536 spec page 382)
   \ Enable LPC interrupt inputs 12 and 1
   h# 0.0000.1002.  h# 5140.0025  wrmsr

   \ (5536 spec page 467-8)
   \ Enable Serial IRQ 80, with IRQs 12 and 1 active high
   h# 0.effd.0080.  h# 5140.004e  wrmsr
;

\ Execute the definition created above.
\ It wasn't really necessary to make a new definition to do this.
\ It would have worked just to issue the wrmsr commands directly.
\ But since the changes go together, perhaps it is nicer to package them.

fix-interrupt-routing


\ The commented-out line below is an example of changing the boot arguments.
\ The standard configuration variable 'boot-file' holds the OS arguments.
\ Normally, 'setenv' stores the data in non-volatile storage, but in the
\ disk-booted version, OFW has no non-volatile storage at its disposal.  In
\ that case, setenv changes the RAM copy of the variable value, but it doesn't
\ persist across reboots.  But since this file is reloaded each time, that doesn't
\ matter.  BTW, if you just want to change the value temporarily, you can use
\ 'editenv boot-file' from the ok prompt.

\ setenv boot-file ro quiet i8042.debug=1 root=LABEL=OLPCRoot rootfstype=ext3 console=ttyS0,115200 console=tty0 fbcon=font:SUN12x22 pci=nobios video=gxfb:1024x768-16

\ Here is an example of changing the name of the kernel file to boot:

\ setenv boot-device disk:\boot\new_vmlinuz

\ ... and the ramdisk:

\ setenv ramdisk disk:\boot\new_initrd.img
